from v6d2ctx.context import Context
from v6d3music.core.real_url import real_url
from v6d3music.core.aservicing import AServicing
from v6d3music.core.audio import Audio
from v6d3music.utils.argctx import BoundCtx, InfoCtx

__all__ = ("create_audio",)


async def _create_audio(servicing: AServicing, bound: BoundCtx) -> Audio:
    return Audio(
        servicing,
        await real_url(bound.url, False),
        bound.url,
        bound.description,
        bound.options,
        bound.member,
        bound.already_read,
    )


async def create_audio(servicing: AServicing, ctx: Context, it: InfoCtx) -> Audio:
    bound = it.bind(ctx)
    return await _create_audio(servicing, bound)
